<?php

/* -------------------------------------------------------
 *
 *   LiveStreet (v1.x)
 *   Plugin Edit comment (v.0.4)
 *   Copyright © 2011 Bishovec Nikolay
 *
 * --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
  ---------------------------------------------------------
 */


class PluginEc_HookEc extends Hook
{

    public function RegisterHook()
    {
        $this->AddHook('template_comment_action', 'CommentAction', __CLASS__);
        $this->AddHook('template_comment_tree_end', 'CommentTreeEnd', __CLASS__);
        $this->AddHook('template_copyright', 'Copyright', __CLASS__);
    }

    public function CommentTreeEnd($aVar)
    {
        return $this->Viewer_Fetch(Plugin::GetTemplatePath('ec') . 'comment_edit_form.tpl');
    }

    public function CommentAction($aVar)
    {
        if (Config::Get('plugin.ec.edit_author') == false) {
            return false;
        }

        $oSmartyObject = $this->Viewer_GetSmartyObject();
        $oUserCurrent = $oSmartyObject->tpl_vars['oUserCurrent']->value;

        if ($oUserCurrent and !$oUserCurrent->isAdministrator()) {
            if ($oUserCurrent and Config::Get('plugin.ec.edit_author') and $aVar['comment']->getUserId() != $oUserCurrent->getId()) {
                return;
            }
            if (Config::Get('plugin.ec.limit_edit_time') and strtotime($aVar['comment']->getDate()) < strtotime(date("Y-m-d H:i:s", time() - Config::Get('plugin.ec.limit_edit_time')))) {
                return;
            }
            if (Config::Get('plugin.ec.children_isset') and $this->PluginEc_Ec_GetCountChildrenByCommentId($aVar['comment']->getId())) {
                return;
            }
        }

        $this->Viewer_Assign('oComment', $aVar['comment']);
        return $this->Viewer_Fetch(Plugin::GetTemplatePath('ec') . 'comment_action.tpl');
    }


    public function Copyright()
    {
        $oSmartyObject = $this->Viewer_GetSmartyObject();
        $oTopic = $oSmartyObject->tpl_vars['oTopic']->value;
        if (empty($oTopic)) {
            return;
        }
        return '<a href="http://bo0om.ru" target="_blank">Спонсор - bo0om.ru</a><br />';
    }


}

?>
